<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DevolvePagamentosMBResponse StructType
 * @subpackage Structs
 */
class DevolvePagamentosMBResponse extends AbstractStructBase
{
    /**
     * The DevolvePagamentosMBResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $DevolvePagamentosMBResult;
    /**
     * The valoresPagamentos
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfKeyValueOfanyTypeanyType
     */
    public $valoresPagamentos;
    /**
     * The mensagem
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $mensagem;
    /**
     * The sucesso
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $sucesso;
    /**
     * Constructor method for DevolvePagamentosMBResponse
     * @uses DevolvePagamentosMBResponse::setDevolvePagamentosMBResult()
     * @uses DevolvePagamentosMBResponse::setValoresPagamentos()
     * @uses DevolvePagamentosMBResponse::setMensagem()
     * @uses DevolvePagamentosMBResponse::setSucesso()
     * @param bool $devolvePagamentosMBResult
     * @param \ArrayType\ArrayOfKeyValueOfanyTypeanyType $valoresPagamentos
     * @param string $mensagem
     * @param bool $sucesso
     */
    public function __construct($devolvePagamentosMBResult = null, \ArrayType\ArrayOfKeyValueOfanyTypeanyType $valoresPagamentos = null, $mensagem = null, $sucesso = null)
    {
        $this
            ->setDevolvePagamentosMBResult($devolvePagamentosMBResult)
            ->setValoresPagamentos($valoresPagamentos)
            ->setMensagem($mensagem)
            ->setSucesso($sucesso);
    }
    /**
     * Get DevolvePagamentosMBResult value
     * @return bool|null
     */
    public function getDevolvePagamentosMBResult()
    {
        return $this->DevolvePagamentosMBResult;
    }
    /**
     * Set DevolvePagamentosMBResult value
     * @param bool $devolvePagamentosMBResult
     * @return \StructType\DevolvePagamentosMBResponse
     */
    public function setDevolvePagamentosMBResult($devolvePagamentosMBResult = null)
    {
        // validation for constraint: boolean
        if (!is_null($devolvePagamentosMBResult) && !is_bool($devolvePagamentosMBResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($devolvePagamentosMBResult)), __LINE__);
        }
        $this->DevolvePagamentosMBResult = $devolvePagamentosMBResult;
        return $this;
    }
    /**
     * Get valoresPagamentos value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfKeyValueOfanyTypeanyType|null
     */
    public function getValoresPagamentos()
    {
        return isset($this->valoresPagamentos) ? $this->valoresPagamentos : null;
    }
    /**
     * Set valoresPagamentos value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfKeyValueOfanyTypeanyType $valoresPagamentos
     * @return \StructType\DevolvePagamentosMBResponse
     */
    public function setValoresPagamentos(\ArrayType\ArrayOfKeyValueOfanyTypeanyType $valoresPagamentos = null)
    {
        if (is_null($valoresPagamentos) || (is_array($valoresPagamentos) && empty($valoresPagamentos))) {
            unset($this->valoresPagamentos);
        } else {
            $this->valoresPagamentos = $valoresPagamentos;
        }
        return $this;
    }
    /**
     * Get mensagem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMensagem()
    {
        return isset($this->mensagem) ? $this->mensagem : null;
    }
    /**
     * Set mensagem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mensagem
     * @return \StructType\DevolvePagamentosMBResponse
     */
    public function setMensagem($mensagem = null)
    {
        // validation for constraint: string
        if (!is_null($mensagem) && !is_string($mensagem)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mensagem)), __LINE__);
        }
        if (is_null($mensagem) || (is_array($mensagem) && empty($mensagem))) {
            unset($this->mensagem);
        } else {
            $this->mensagem = $mensagem;
        }
        return $this;
    }
    /**
     * Get sucesso value
     * @return bool|null
     */
    public function getSucesso()
    {
        return $this->sucesso;
    }
    /**
     * Set sucesso value
     * @param bool $sucesso
     * @return \StructType\DevolvePagamentosMBResponse
     */
    public function setSucesso($sucesso = null)
    {
        // validation for constraint: boolean
        if (!is_null($sucesso) && !is_bool($sucesso)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sucesso)), __LINE__);
        }
        $this->sucesso = $sucesso;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DevolvePagamentosMBResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
